<?php
/**
* Joomla Community Builder User Plugin: plug_cbiplog
* @author Thomas Kampp, www.toolmaster.dk
* @copyright (C) 2007 by Thomas Kampp, www.toolmaster.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

# Joomla/Mambo Safety
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class getPublicMailTab extends cbTabHandler {
/*
	# Constructor
	function getPublicmailTab() {
		$this->cbTabHandler();
	}
*/

	# Create form/text/content and insert in frontend!
	function showForm($userid, $publicmailTableWidth, $publicmailShowIntro, $publicmailShowAddress, $publicmailUseSubject, $publicmailUseCopy, $publicmailTextMaxlength, $publicmailTextRows, $publicmailTextCols) {
		global $my;

		# Javascript that checks that form has been filled in
		echo "<script language=\"Javascript\">";
		echo "  function validate(){";
		echo "    if ((document.mailForm.mailName.value=='') || (document.mailForm.mailMail.value=='') || (document.mailForm.mailText.value=='')){";
		echo "      alert(\""._PM_FORM_ALERT."\");";
		echo "    } else {";
		echo "      document.entryForm.action = 'index.php';";
		echo "      document.entryForm.submit();";
		echo "    }";
		echo "  }";
		echo "</script>\n";
		
		# Javascript that makes maxlength in textarea work!
		?>
		<script type="text/javascript">
		function ismaxlength(obj){
		var mlength=obj.getAttribute? parseInt(obj.getAttribute("maxlength")) : ""
		if (obj.getAttribute && obj.value.length>mlength)
			obj.value=obj.value.substring(0,mlength)
		}
		</script>
		<?

		# Start form and insert hidden return values
		$content = "<form name=\"mailForm\" action=\"index.php\" method=\"post\">";
		$content .= "<input type='hidden' name='option' value='com_comprofiler'>";
    	$content .= "<input type='hidden' name='task' value='userProfile'>"; // Hvilken func i main-switch der skal loades om lidt!
    	$content .= "<input type='hidden' name='user' value='$userid'>"; // Her fortlles hvilken type der skal gemmes
		$itemId = mosGetParam( $_REQUEST, 'itemId', '' );
    	$content .= "<input type='hidden' name='itemId' value='$itemId'>"; // Hvis denne er sat betyder det at det er en edit og ikke en nyt indlg!		

		# Show the form content
		$content .= "<table cellpadding=\"1\" cellspacing=\"0\" border=\"0\" width=\"".$publicmailTableWidth."\"><tr><td align=\"left\">";
		$content .= $publicmailShowIntro."<br>";
		if ($publicmailShowAddress) {
		$email = $this->getProfileMail($userid);
		$content .= _PM_FORM_EMAIL." <a href=\"mailto:".$email."\">".$email."</a>";
		}
		$content .= "</td></tr><tr><td align=\"left\" valign=\"top\">";
		$content .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr><td align=\"left\" width=\"35%\">";
		$content .= _PM_FORM_NAME.": </td><td><input type=\"text\" name=\"mailName\" class=\"inputbox\" value=\"$my->username\" maxlength=\"40\">";
		$content .= "</td></tr><tr><td align=\"left\" width=\"35%\">";
		$content .= _PM_FORM_MAIL.": </td><td><input type=\"text\" name=\"mailMail\" class=\"inputbox\" value=\"$my->email\" maxlength=\"40\">";
		if ($publicmailUseSubject) {
		$content .= "</td></tr><tr><td align=\"left\" width=\"35%\">";
		$content .= _PM_FORM_SUBJECT.": </td><td><input type=\"text\" name=\"mailSubject\" class=\"inputbox\" maxlength=\"255\">";
		}
		$content .= "</td></tr></table>";
		$content .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr><td align=\"left\">";
		$content .= _PM_FORM_MESSAGE.": <br><textarea wrap=\"virtual\" name=\"mailText\" class=\"inputbox\" onkeyup=\"return ismaxlength(this)\" maxlength=\"".$publicmailTextMaxlength."\" rows=\"".$publicmailTextRows."\" cols=\"".$publicmailTextCols."\"></textarea>";
		if ($publicmailUseCopy) {
		$content .= "</td></tr><tr><td align=\"left\">";
		$content .= "<input type=\"checkbox\" name=\"sendCopy\" class=\"inputbox\" value=\"sendCopy\" /> "._PM_FORM_COPY;
		}
		$content .= "</td></tr><tr><td align=\"left\">";
		$content .= "<input type=\"submit\" value=\""._PM_FORM_BUTTON."\" class=\"button\" onClick=\"validate()\">";
		$content .= "</td></tr></table></td></tr></table>";
		$content .= "</form>";

		return $content;
	}


	# Tjek om en email virkelig er en email
	function is_email($email){
			$emailstatus=false;
			if(preg_match("/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $email)) {
			  $emailstatus=true;
			}
			return $emailstatus;
	}


	# Make the input save-safe
	function makeTextSafe($text) {
			$text = strip_tags($text);
			$text = mysql_escape_string($text);
			return $text;
	}


	# Get profileowners email
	function getProfileMail($userid) {
		global $database;

		# Find users email (perhaps this does not work if too many users has been deleted at recreated etc.)
		$database->setQuery( "SELECT email FROM #__users WHERE id='$userid'" );
		$row = $database->loadObjectList();
		$email = $row[0]->email;

		return $email;
	}


	# Get profileowners username
	function getProfileUsername($userid) {
		global $database;

		# Find users username (perhaps this does not work if too many users has been deleted at recreated etc.)
		$database->setQuery( "SELECT username FROM #__users WHERE id='$userid'" );
		$row = $database->loadObjectList();
		$username = $row[0]->username;

		return $username;
	}


	# Add/log sendt mail to database
	function addMailToDB($userid, $is_user, $name, $mail, $subj, $text) {
		global $database, $my;

		# Find all variables for database entry and make them safe
		if ($is_user) { $senderid = $my->id; } else { $senderid = _PM_LOG_USER_IS_UNKNOWN; }// Find user id
		$senderip 	= getenv('REMOTE_ADDR'); // Find user IP. Also  $_SERVER['REMOTE_ADDR'];  can be used!
		$sendername = $this->makeTextSafe($name);
		$sendermail = $this->makeTextSafe($mail);
		$recieverid = $this->makeTextSafe($userid);
		$recieverusername = $this->getProfileUsername($userid);
		$maildate 	= date("y/m/d g:i:s"); // Find current date and time acoording to the server
		$mailsubject= $this->makeTextSafe($subj);
		$mailtext 	= $this->makeTextSafe($text);

		# Inserting into database
		$query="INSERT INTO #__comprofiler_plug_publicmail SET senderid='$senderid', senderip='$senderip', sendername='$sendername', sendermail='$sendermail', recieverid='$recieverid', recieverusername='$recieverusername', maildate='$maildate', mailsubject='$mailsubject', mailtext='$mailtext'";
		$database->setquery($query);
		// print $database->getQuery();
		$database->query();
	}


	# Mail reciever
	function mailReciever($userid, $name, $mail, $subj, $text) {
		global $mosConfig_live_site;

		# Compose message
		$reciever = $this->getProfileMail($userid);
		$subject  = $subj;
		$mailtext = _PM_MAIL_GREETING." ".$this->getProfileUsername($userid)."\r\n\r\n"._PM_RECIEVER_MESSAGE1." ".$mosConfig_live_site." "._PM_RECIEVER_MESSAGE2." ".$name." (".$mail."): \r\n\r\n".$text."\r\n\r\n\r\n\r\n"._PM_RECIEVER_FOOTER;

		$mailtext = stripslashes($mailtext);
		$mailtext = wordwrap($mailtext, 70); // Just to be safe that SMTP-send works
		$subject = stripslashes($subject);

		# Send the mail!
		//mosMail($mail, $name, $reciever, $subject, $mailtext); // http://help.mamboserver.com/api/Mambo/_includes_mambo_php.html
		@mail($reciever,$subject,$mailtext,"From: $mail");

	}


	# Mail copy
	function mailCopy($userid, $name, $mail, $subj, $text) {
		global $mosConfig_live_site, $mosConfig_mailfrom;

		# Compose message
		$reciever = $mail;
		$subject  = _PM_COPY_SUBJECT." ".$subj;
		$mailtext = _PM_MAIL_GREETING." ".$name."\r\n\r\n"._PM_COPY_MESSAGE1." ".$this->getProfileUsername($userid)." "._PM_COPY_MESSAGE2." ".$mosConfig_live_site."\r\n\r\n".$text."\r\n\r\n\r\n\r\n"._PM_MAIL_FOOTER;

		$mailtext = stripslashes($mailtext);
		$mailtext = wordwrap($mailtext, 70); // Just to be safe that SMTP-send works
		$subject = stripslashes($subject);

		# Send the mail!
		// mosMail($mosConfig_mailfrom, $mosConfig_live_site, $reciever, $subject, $mailtext); // http://help.mamboserver.com/api/Mambo/_includes_mambo_php.html
		@mail($reciever,$subject,$mailtext,"From: $mosConfig_mailfrom");

	}


	# Mail sender ("thank you")
	function mailSenderThanks($userid, $is_user, $name, $mail) {
		global $mosConfig_live_site, $mosConfig_mailfrom;

		# Compose message
		$reciever = $mail;
		$subject = _PM_THANKU_SUBJECT." ".$mosConfig_live_site;
		$mailtext  = _PM_MAIL_GREETING." ".$name."\r\n\r\n"._PM_THANKU_THANKS." ".$mosConfig_live_site."\r\n\r\n"._PM_MAIL_FOOTER;

		# Send the mail!
		//mosMail($mosConfig_mailfrom, $mosConfig_live_site, $reciever, $subject, $mailtext); // http://help.mamboserver.com/api/Mambo/_includes_mambo_php.html
		@mail($reciever,$subject,$mailtext,"From: $mosConfig_mailfrom");

	}


	# Send mails and log
	function sendMails($userid, $is_user, $publicmailLogMails, $publicmailThankSender, $name, $mail, $subj, $text, $copy) {

		# Send mail
		$this->mailReciever($userid, $name, $mail, $subj, $text);
		# Send copy
		if ($copy=="sendCopy") { $this->mailCopy($userid, $name, $mail, $subj, $text); }
		# Send thanks
		if ($publicmailThankSender) { $this->mailSenderThanks($userid, $is_user, $name, $mail); }
		# Log mail
		if ($publicmailLogMails) { $this->addMailToDB($userid, $is_user, $name, $mail, $subj, $text); }
	}


	# Main funtion!
	function getDisplayTab($tab,$user) {
		global $mosConfig_absolute_path, $mosConfig_lang, $my;

		# Get site language
		if (file_exists($mosConfig_absolute_path.'/components/com_comprofiler/plugin/user/plug_cbpublicmail/languages/'.$mosConfig_lang.'.php')) {
		  include($mosConfig_absolute_path.'/components/com_comprofiler/plugin/user/plug_cbpublicmail/languages/'.$mosConfig_lang.'.php');
		} else {
		  include($mosConfig_absolute_path.'/components/com_comprofiler/plugin/user/plug_cbpublicmail/languages/english.php');
		}

		# Load parameters
		$params=$this->params;
		$publicmailShowForm 	= $params->get('publicmailShowForm', "0");
		$publicmailTableWidth 	= $params->get('publicmailTableWidth', "100%");
		$publicmailShowIntro 	= $params->get('publicmailShowIntro', "If you want to contact this person, you may use this email-form:");
		$publicmailShowAddress 	= $params->get('publicmailShowAddress', "0");
		$publicmailUseSubject 	= $params->get('publicmailUseSubject', "1");
		$publicmailUseCopy 		= $params->get('publicmailUseCopy', "0");
		$publicmailTextMaxlength= $params->get('publicmailTextMaxlength', "500");
		$publicmailTextRows 	= $params->get('publicmailTextRows', "5");
		$publicmailTextCols 	= $params->get('publicmailTextCols', "40");
		$publicmailThankSender  = $params->get('publicmailThankSender', "0");
		$publicmailLogMails 	= $params->get('publicmailLogMails', "0");

		# Find userlevels
		$is_user = (strtolower($my->usertype) <> '');

		# Active profile
		$userid = mosGetParam( $_REQUEST, 'user', '' );

		# Variables to check if form has been filled in and email(s) needs to be sendt
		$name = $_POST['mailName'];
		$mail = $_POST['mailMail'];
		$subj = $_POST['mailSubject'];
		$text = $_POST['mailText'];
		$copy = $_POST['sendCopy'];

		# Show/load content/plugin
		if ($name AND $this->is_email($mail) AND $text) { // If an email has been sendt
			$name = $this->makeTextSafe($name); $mail = $this->makeTextSafe($mail); $subj = $this->makeTextSafe($subj); $text = $this->makeTextSafe($text);
			$this->sendMails($userid, $is_user, $publicmailLogMails, $publicmailThankSender, $name, $mail, $subj, $text, $copy);
			$content = _PM_MAIL_HAS_BEEN_SENDT;
		} else if ($userid==$my->id) { // If own profile is visited
			$content = _PM_VISITING_OWN_PROFILE;
		} else if (($publicmailShowForm=="1" AND $is_user) OR $publicmailShowForm=="0") { // Show mail-form to "All registred users!" or "All users!"
			$content = $this->showForm($userid, $publicmailTableWidth, $publicmailShowIntro, $publicmailShowAddress, $publicmailUseSubject, $publicmailUseCopy, $publicmailTextMaxlength, $publicmailTextRows, $publicmailTextCols);
		}

		return $content;
	} // end getDisplayTab
}	// end class getPublicMailTab.
?>